<?php

namespace Drupal\drush_endpoint\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\drush_endpoint\Service\DrushExecutor;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\JsonResponse;

#[\Attribute]
final class DrushController extends ControllerBase {
  public function __construct(
    private readonly DrushExecutor $drushExecutor,
  ) {}

  public static function create(ContainerInterface $container): self {
    $drushExecutor = $container->get('drush_endpoint.executor');
    if (!$drushExecutor instanceof DrushExecutor) {
      throw new \RuntimeException('Expected DrushExecutor service');
    }

    return new self($drushExecutor);
  }

  public function executeCommand(string $command): JsonResponse {
    $result = $this->drushExecutor->execute($command);
    return new JsonResponse($result);
  }
}
